VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TheGame"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
    
Dim bInWindow As Boolean
Dim bmp_file As String

Dim UsedObjects As Long

Dim Donut(10) As New Donut
Dim Small(20) As New Small
Dim Smaller(40) As New Smaller
Dim Smallest(80) As New Smallest
Dim bullets(30) As New Bullet
Dim Letter  As New Letter
Public Ship As New Ship

Dim lScore As Long  'Aktuelle Punktzahl
Dim lFps As Long    'Frames per Second Perfomace

Dim ddsdesc As DDSURFACEDESC
Dim ddscaps As ddscaps
Dim DDBLTFX As DDBLTFX
Dim ddck As DDCOLORKEY

Dim lpDD As Long                  'DirectDraw Interface
Dim lpPrimarySurface As Long      'FrontSurface Interface
Dim lpBackgroundSurface As Long   'BackSurface Interface
Dim lpOffscreenSurface As Long    'OfscreenSurface Interface
Dim lpPalette As Long             'Palette

Dim rScreen As lRECT              'Gre des Bildschirm
Dim rVisibleScreen As lRECT       'Im FensterModus ist dieses Rechteck evtl. kleiner

Dim dwTransparentColor As Long
    
Dim bRunning As Boolean
    
Dim lTickStart As Long
Dim lTickNow As Long
Dim lTick As Long

Dim lLevel As Long
Dim lLevelClock As Long
    
Function CreateOverlay(ByVal lpDD As Long)
    If AreOverlaysSupported(lpDD) Then
    End If
End Function
    
Public Sub Level(ByVal n As Integer)  'Jeder Level enthlt die angegebene Anzahl von Donuts (max. UBound(Donuts))
  Dim k As Long
  Dim p As lPOINT
  
  If n > UBound(Donut) Then n = UBound(Donut)
  
  UsedObjects = 0
  lLevelClock = 0
  lLevel = n
  
  For k = 0 To n - 1
    Randomize GetTickCount()
    RandomPosition p, rVisibleScreen
    
    Donut(k).Sprite.Visible = True
    Donut(k).Sprite.x = p.x
    Donut(k).Sprite.y = p.y
    Donut(k).Animate CInt(Rnd * 39)
    Donut(k).Sprite.Speed = 1
    Donut(k).Sprite.Distance = -1
    Donut(k).Sprite.Direction = (Rnd * 3600)
    Donut(k).Sprite.Velocity = 0
    UsedObjects = UsedObjects + 1
  Next
End Sub

Public Function Init(f As Form, w As Long, h As Long, bpp As Long) As Boolean
  Dim CoOp As Long
  Dim hResult As Long
  Dim j As Long
  Dim p As lPOINT
  
  
  bmp_file = App.Path & "\donuts.bmp"
  
  lFps = 0
  
  bInWindow = (w = 0) Or (h = 0)
  
  'Directdraw Objekt erzeugen
  If ddDirectDrawCreate(0, ptr(lpDD), 0) = DD_OK Then
    CreateOverlay lpDD
    If bInWindow Then
      CoOp = DDSCL_NORMAL
    Else
      CoOp = DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWMODEX
    End If
    
    'Kooperative Level setzen
    If DirectDraw_SetCooperativeLevel(lpDD, f.hWnd, CoOp) = DD_OK Then
      
      'Display-Mode setzen
      If bInWindow Then
        hResult = DD_OK
      Else
        hResult = DirectDraw_SetDisplayMode(lpDD, w, h, bpp)
      End If
      
      If hResult = DD_OK Then
        'Primary und Background-Surface erzeugen
        ddsdesc.dwSize = Len(ddsdesc)
        If bInWindow Then
          ddsdesc.dwFlags = DDSD_CAPS
          ddsdesc.ddscaps.dwCaps = DDSCAPS_PRIMARYSURFACE
        Else
          ddsdesc.dwFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
          ddsdesc.ddscaps.dwCaps = DDSCAPS_PRIMARYSURFACE Or DDSCAPS_COMPLEX Or DDSCAPS_FLIP
          ddsdesc.dwBackBufferCount = 1
        End If
        If DirectDraw_CreateSurface(lpDD, ptr(ddsdesc), ptr(lpPrimarySurface), 0) = DD_OK Then
          
          'Dimensionen der Primary Surface ermitteln
          DirectDrawSurface_GetSurfaceDesc lpPrimarySurface, ptr(ddsdesc)
          If bInWindow Then 'Im Fenster
            'hole aktuelle Surface
            ddsdesc.dwFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH Or DDSD_PIXELFORMAT
            ddsdesc.ddscaps.dwCaps = DDSCAPS_OFFSCREENPLAIN
            'ddsdesc.dwWidth = ddsd.dwWidth
            'ddsdesc.dwHeight = ddsd.dwHeight   'Werden ausgelesen
            'ddsdesc.ddpfPixelFormat = ddsd.ddpfPixelFormat
            hResult = DirectDraw_CreateSurface(lpDD, ptr(ddsdesc), ptr(lpBackgroundSurface), 0)
            GetWindowRect f.hWnd, rVisibleScreen
            rVisibleScreen.right = rVisibleScreen.right - rVisibleScreen.left
            rVisibleScreen.bottom = rVisibleScreen.bottom - rVisibleScreen.top
            rVisibleScreen.left = 0
            rVisibleScreen.top = 0
            
            rScreen.right = ddsdesc.dwWidth
            rScreen.bottom = ddsdesc.dwHeight
            rScreen.left = 0
            rScreen.top = 0
          Else
            'Background-Surface ermitteln
            ddscaps.dwCaps = DDSCAPS_BACKBUFFER
            hResult = DirectDrawSurface_GetAttachedSurface(lpPrimarySurface, ptr(ddscaps), ptr(lpBackgroundSurface))
            
            rScreen.left = 0
            rScreen.top = 0
            rScreen.right = ddsdesc.dwWidth
            rScreen.bottom = ddsdesc.dwHeight
            rVisibleScreen = rScreen
          End If
          
      
          If hResult = DD_OK Then
            'Farben der Grafik aus BMP-Datei laden
            DDLoadPalette lpDD, bmp_file, 0, ptr(lpPalette)
            If lpPalette Then
              'Die Palette mu vor dem Laden der Bitmaps erfolgen!
              DirectDrawSurface_SetPalette lpPrimarySurface, lpPalette
              
              'Offscreen-Surface aus Bitmap erzeugen
              If DDLoadBitmap(lpDD, bmp_file, 0&, 0&, ptr(lpOffscreenSurface)) = DD_OK Then
                 
                 'ColorKey der Background-Surface auf SCHWARZ setzen
                 DDSetSrcColorKey lpOffscreenSurface, DDColorMatch(lpOffscreenSurface, &H0)
                 
                 'Animationslkalssen initialisieren
                 For j = LBound(Donut) To UBound(Donut)
                   Donut(j).Sprite.SetOffscreenSurface lpOffscreenSurface
                   Donut(j).Animate CInt(Rnd * 39)
                   Donut(j).Sprite.Visible = False
                 Next
                 For j = LBound(Small) To UBound(Small)
                   Small(j).Sprite.SetOffscreenSurface lpOffscreenSurface
                   Small(j).Animate CInt(Rnd * 31)
                   Small(j).Sprite.Visible = False
                 Next
                 For j = LBound(Smaller) To UBound(Smaller)
                   Smaller(j).Sprite.SetOffscreenSurface lpOffscreenSurface
                   Smaller(j).Animate CInt(Rnd * 31)
                   Smaller(j).Sprite.Visible = False
                 Next
                 For j = LBound(Smallest) To UBound(Smallest)
                   Smallest(j).Sprite.SetOffscreenSurface lpOffscreenSurface
                   Smallest(j).Animate CInt(Rnd * 31)
                   Smallest(j).Sprite.Visible = False
                 Next
                 For j = LBound(bullets) To UBound(bullets)
                   bullets(j).Sprite.SetOffscreenSurface lpOffscreenSurface
                   bullets(j).Sprite.Visible = False
                 Next
                 
                 Letter.Sprite.SetOffscreenSurface lpOffscreenSurface
                 Letter.Sprite.Visible = True
                 
                 RandomPosition p, rVisibleScreen
                 Ship.Sprite.SetOffscreenSurface lpOffscreenSurface
                 Ship.Animate 0
                 Ship.Sprite.Move p.x, p.y
                 Ship.Sprite.Visible = True
                 
                 Init = True
                 bRunning = True
                 lTickStart = GetTickCount()
                 
                 Level 0  'Mit Level 0 beginnen (wird aber sofort zu Level 1)
                 
                 Exit Function
              End If
            End If
          End If
        End If
      End If
    End If
  End If
  Cleanup
End Function

'Hier wird das Spiel am Laufen gehalten und immer weiter vorangetrieben
Public Sub NextTick(ByVal hWnd As Long)
  Dim w As Double
  Dim rDst As lRECT, rSrc As lRECT
  Dim j As Long
  Dim s As String
  
  If Not IsRunning() Then Exit Sub
  If lpPalette = 0 Then Exit Sub
  If lpOffscreenSurface = 0 Then Exit Sub
  If lpBackgroundSurface = 0 Then Exit Sub
  If lpPrimarySurface = 0 Then Exit Sub
  If lpDD = 0 Then Exit Sub
  
  'Neuen Level beginnen?
  If UsedObjects = 0 Then 'Nichts mehrzum Abballern da?
    If lLevelClock = 0 Then
      lLevel = lLevel + 1
      lLevelClock = GetTickCount()
    Else
      If GetTickCount() - lLevelClock > 2000 Then
        Level lLevel
      End If
    End If
  End If
  
  'Zwischenzeitlich Surfaces verloren gegangen?
  If DirectDrawSurface_IsLost(lpPrimarySurface) = DDERR_SURFACELOST Then
    DirectDrawSurface_Restore lpPrimarySurface
  End If
  
  If DirectDrawSurface_IsLost(lpBackgroundSurface) = DDERR_SURFACELOST Then
    DirectDrawSurface_Restore lpBackgroundSurface
  End If
  
  If DirectDrawSurface_IsLost(lpOffscreenSurface) = DDERR_SURFACELOST Then
    DirectDrawSurface_Restore lpOffscreenSurface
    DDReLoadBitmap lpOffscreenSurface, bmp_file
    'DDSetSrcColorKey lpOffscreenSurface, DDColorMatch(lpOffscreenSurface, &H0) 'Schwarz ist Transparent
  End If
  
  lTickNow = GetTickCount()
  
  'Hintergrund lschen
  FillSurfaceRect lpBackgroundSurface, rgb(0, 0, 0), rVisibleScreen
  
  'Alle Sprites in background-Surface Zeichnen
  For j = LBound(Donut) To UBound(Donut)
    Donut(j).Sprite.Draw lpBackgroundSurface, 0, 0
    Donut(j).Sprite.NextSpeed
    Donut(j).NextAnimate
    Donut(j).Sprite.Bounce rVisibleScreen.left, rVisibleScreen.top, rVisibleScreen.right, rVisibleScreen.bottom
  Next
  
  For j = LBound(Small) To UBound(Small)
    Small(j).Sprite.Draw lpBackgroundSurface, 0, 0
    Small(j).Sprite.NextSpeed
    Small(j).NextAnimate
    Small(j).Sprite.Bounce rVisibleScreen.left, rVisibleScreen.top, rVisibleScreen.right, rVisibleScreen.bottom
  Next
  
  For j = LBound(Smaller) To UBound(Smaller)
    Smaller(j).Sprite.Draw lpBackgroundSurface, 0, 0
    Smaller(j).Sprite.NextSpeed
    Smaller(j).NextAnimate
    Smaller(j).Sprite.Bounce rVisibleScreen.left, rVisibleScreen.top, rVisibleScreen.right, rVisibleScreen.bottom
  Next
  
  For j = LBound(Smallest) To UBound(Smallest)
    Smallest(j).Sprite.Draw lpBackgroundSurface, 0, 0
    Smallest(j).Sprite.NextSpeed
    Smallest(j).NextAnimate
    Smallest(j).Sprite.Bounce rVisibleScreen.left, rVisibleScreen.top, rVisibleScreen.right, rVisibleScreen.bottom
  Next
  For j = LBound(bullets) To UBound(bullets)
    If bullets(j).Sprite.Visible Then
      bullets(j).Sprite.Draw lpBackgroundSurface, 0, 0
      bullets(j).Sprite.NextSpeed
      bullets(j).NextAnimate
      bullets(j).Sprite.Bounce rVisibleScreen.left, rVisibleScreen.top, rVisibleScreen.right, rVisibleScreen.bottom
      If bullets(j).Sprite.Distance <= 0 Then bullets(j).Sprite.Visible = False
    End If
  Next

  'Auch das Shiiff zeichnen
  Ship.Sprite.Draw lpBackgroundSurface, 0, 0
  Ship.Sprite.NextSpeed
  Ship.Sprite.Bounce rVisibleScreen.left, rVisibleScreen.top, rVisibleScreen.right, rVisibleScreen.bottom
  
  HitTest 'Kollisionen prfen, damit beim nchsten mal alle Getroffenen Objekte verschwunden sind
  
  'Soll der Text "Level xxx" angezeigt werden?
  If UsedObjects = 0 Then
    j = (2000 - (GetTickCount() - lLevelClock)) / 200
    If j > 100 Then j = 100
    s = "Level " & lLevel & "   " & j
    Letter.TextOut lpBackgroundSurface, (rVisibleScreen.right - Len(s) * 16) / 2, (rVisibleScreen.bottom - 16) / 2, s
  Else
    Letter.TextOut lpBackgroundSurface, 10, 10, CStr(lScore)
  End If
      
  'Ausgabegeschwindigkeit berechnen (gemittelt auf jeweils 10 Sekunden)
  lFps = lFps + 1
  lTick = lTickNow - lTickStart
  If lTick Then
    Letter.TextOut lpBackgroundSurface, 30, 30, CStr(CInt((lFps * 1000&) \ lTick))
    If lTick > 10000 Then
      lTickStart = GetTickCount()
      lFps = 0
    End If
  End If
      
  If bInWindow Then
    'Im Fenster Modus ist alles etwas komplizierter
    GetWindowRect hWnd, rDst
    
    If rDst.right - rDst.left > GetSystemMetrics(SM_CXSCREEN) Then 'Wenn das Fenster maximiert istm sind die Windows-Koordinaten negativ
      rDst = rScreen
    End If
    
    If rDst.bottom - rDst.top > GetSystemMetrics(SM_CYSCREEN) Then 'Wenn das Fenster maximiert istm sind die Windows-Koordinaten negativ
      rDst = rScreen
    End If
    
    rSrc.left = 0
    rSrc.top = 0
    rSrc.right = rDst.right - rDst.left
    rSrc.bottom = rDst.bottom - rDst.top
    'Achtung! Das ZTielrechteck win in Screen-Kooridnaten angegeben
    DirectDrawSurface_Blt lpPrimarySurface, ptr(rDst), lpBackgroundSurface, ptr(rSrc), DDBLT_WAIT, 0
  Else
    'Background-Surface anzeigen
    DirectDrawSurface_Flip lpPrimarySurface, 0, DDFLIP_WAIT
  End If
End Sub

Public Sub Cleanup()
  If lpPalette Then Unknown_Release lpPalette: lpPalette = 0
  If lpOffscreenSurface Then Unknown_Release lpOffscreenSurface: lpOffscreenSurface = 0
  If lpBackgroundSurface Then Unknown_Release lpBackgroundSurface: lpBackgroundSurface = 0
  If lpPrimarySurface Then Unknown_Release lpPrimarySurface: lpPrimarySurface = 0
  If lpDD Then
    DirectDraw_FlipToGDISurface lpDD      'GDI/Desktop anzeigen
    DirectDraw_RestoreDisplayMode lpDD    'Auflsung wiederherstellen
    Unknown_Release lpDD: lpDD = 0
  End If
End Sub

'Diese Funktipon berprft, welches Sprite von den angegebenen Koordinaten getroffen wurde
'Beim treffer wird das Objekt unsichtbar gemacht und (falls mglich) durch zwei kleinere Objekte ersetzt.
Function Plop(ByVal x As Long, ByVal y As Long) As Boolean
  Dim j As Long
  Dim k As Long
  Dim l As Long

  For j = LBound(Donut) To UBound(Donut)
    If Donut(j).Sprite.Visible Then
      If Donut(j).Sprite.InRect(x, y) Then
        lScore = lScore + 100
        Donut(j).Sprite.Visible = False
        UsedObjects = UsedObjects - 1
        Plop = True
        l = 0
        For k = LBound(Small) To UBound(Small)
          If Small(k).Sprite.Visible = False Then
            Small(k).Sprite.Visible = True
            Small(k).Sprite.x = Donut(j).Sprite.x
            Small(k).Sprite.y = Donut(j).Sprite.y
            Small(k).Animate CInt(Rnd * 31)
            Small(k).Sprite.Speed = 2
            Small(k).Sprite.Distance = -1
            If l = 0 Then
              Small(k).Sprite.Direction = Donut(j).Sprite.Direction - 900
            Else
              Small(k).Sprite.Direction = Donut(j).Sprite.Direction + 900
            End If
            Small(k).Sprite.Velocity = 0
            l = l + 1
            UsedObjects = UsedObjects + 1
          End If
          If l = 2 Then Exit For
        Next
        Exit Function
      End If
    End If
  Next
  
  For j = LBound(Small) To UBound(Small)
    If Small(j).Sprite.Visible Then
      If Small(j).Sprite.InRect(x, y) Then
        lScore = lScore + 200
        Small(j).Sprite.Visible = False
        UsedObjects = UsedObjects - 1
        Plop = True
        l = 0
        For k = LBound(Smaller) To UBound(Smaller)
          If Smaller(k).Sprite.Visible = False Then
            Smaller(k).Sprite.Visible = True
            Smaller(k).Sprite.x = Small(j).Sprite.x
            Smaller(k).Sprite.y = Small(j).Sprite.y
            Smaller(k).Animate CInt(Rnd * 31)
            Smaller(k).Sprite.Speed = 3
            Smaller(k).Sprite.Distance = -1
            If l = 0 Then
              Smaller(k).Sprite.Direction = Small(j).Sprite.Direction - 900
            Else
              Smaller(k).Sprite.Direction = Small(j).Sprite.Direction + 900
            End If
            Smaller(k).Sprite.Velocity = 0
            l = l + 1
            UsedObjects = UsedObjects + 1
          End If
          If l = 2 Then Exit For
        Next
        Exit Function
      End If
    End If
  Next
  
  For j = LBound(Smaller) To UBound(Smaller)
    If Smaller(j).Sprite.Visible Then
      If Smaller(j).Sprite.InRect(x, y) Then
        lScore = lScore + 300
        Smaller(j).Sprite.Visible = False
        UsedObjects = UsedObjects - 1
        Plop = True
        l = 0
        For k = LBound(Smallest) To UBound(Smallest)
          If Smallest(k).Sprite.Visible = False Then
            Smallest(k).Sprite.Visible = True
            Smallest(k).Sprite.x = Smaller(j).Sprite.x
            Smallest(k).Sprite.y = Smaller(j).Sprite.y
            Smallest(k).Animate CInt(Rnd * 31)
            Smallest(k).Sprite.Speed = 4
            Smallest(k).Sprite.Distance = -1
            Smallest(k).Sprite.Direction = (Rnd * 3600)
            
            If l = 0 Then
              Smallest(k).Sprite.Direction = Smaller(j).Sprite.Direction - 900
            Else
              Smallest(k).Sprite.Direction = Smaller(j).Sprite.Direction + 900
            End If

            Smallest(k).Sprite.Velocity = 0
            l = l + 1
            UsedObjects = UsedObjects + 1
          End If
          If l = 2 Then Exit For
        Next
        Exit Function
        
      End If
    End If
  Next
  For j = LBound(Smallest) To UBound(Smallest)
    If Smallest(j).Sprite.Visible Then
      If Smallest(j).Sprite.InRect(x, y) Then
        lScore = lScore + 400
        Smallest(j).Sprite.Visible = False
        UsedObjects = UsedObjects - 1
        Plop = True
      End If
    End If
  Next

End Function

Sub HitTest()
  Dim i As Long
  'berprfe, ob eine Kugel ein Sprtite trifft?
  For i = LBound(bullets) To UBound(bullets)
    If bullets(i).Sprite.Visible Then
      If Plop(bullets(i).Sprite.x, bullets(i).Sprite.y) Then bullets(i).Sprite.Visible = False
    End If
  Next
  'Das Schiff kollidiert mit einem Objekt.
  'Allerdings ist der Spieler derzeit "Unsterblich"
  If Not Ship.shield Then
    Plop Ship.Sprite.x, Ship.Sprite.y
  End If
End Sub

Public Function IsRunning() As Boolean
    IsRunning = bRunning
End Function

Public Sub Resize(f As Form)  'Auf nderung der Fenstergreim Fenstermodus reagieren
  If bInWindow Then 'Im Fenster
    GetWindowRect f.hWnd, rVisibleScreen
    rVisibleScreen.right = rVisibleScreen.right - rVisibleScreen.left
    rVisibleScreen.bottom = rVisibleScreen.bottom - rVisibleScreen.top
    rVisibleScreen.left = 0
    rVisibleScreen.top = 0
    If rVisibleScreen.right > rScreen.right Then rVisibleScreen.right = rScreen.right
    If rVisibleScreen.bottom > rScreen.bottom Then rVisibleScreen.bottom = rScreen.bottom
  End If
End Sub

Public Sub Fire() 'Kugel abfeuern
  Dim j As Integer
  Dim d As Double
  For j = LBound(bullets) To UBound(bullets)
    If Not bullets(j).Sprite.Visible Then
      
      'Kugel in Mittelpunkt des Shiffs plazieren
      bullets(j).Sprite.Move Ship.Sprite.x + Ship.Sprite.w / 2 - 1, Ship.Sprite.y + Ship.Sprite.h / 2 - 1
      d = (3600# * ((Ship.dAnim) Mod 40)) / 40
      
      bullets(j).Sprite.Direction = d
      'Bullets fr eine Drehung des Raumschiffs
      bullets(j).Sprite.Speed = 8
      bullets(j).Sprite.Velocity = 0#
      bullets(j).Sprite.Distance = (UBound(bullets) - LBound(bullets)) * (bullets(j).Sprite.Speed)
      bullets(j).Sprite.Visible = True
      
      'Kugel aus Mittelpunkt herausbewegen
      bullets(j).Sprite.NextSpeed
      bullets(j).Sprite.NextSpeed
      
      If lScore > 0 Then lScore = lScore - 1
      Exit For
    End If
  Next
End Sub


